<%
Class EmmaSMS

	Private Param
	Public ErrMsg
	Public LastPoint
	Public Data

	'***************************************************
	' 클래스를 시작되면 개체를 생성하는 이벤트 핸들러
	'***************************************************
	Private Sub Class_Initialize
		Set Param = server.CreateObject("Scripting.Dictionary")
		Set Data = server.CreateObject("Scripting.Dictionary")
		Param.Item("Lang") = "ASP"
		Param.Item("Char") = "UTF-8"
	End Sub


	'***************************************************
	' 파일을 불러들여 템플릿을 정의하는 함수
	'***************************************************
	Public Function login(id, pass)
		Param.Item("Id") = id
		Param.Item("Pass") = pass
	End Function


	Public Function send(sms_to, sms_from, sms_message, sms_date, sms_type)
		Set oJSON = New aspJSON
		With oJSON.data
			.Add "Lang", Param.Item("Lang")
			.Add "Char", Param.Item("Char")
			.Add "Id", Param.Item("Id")
			.Add "Pass", Param.Item("Pass")
			.Add "To", sms_to
			.Add "From", sms_from
			.Add "Message", sms_message
			.Add "Date", sms_date
			.Add "SmsType", sms_type
		End With

		Dim vsUrl,vsRequestData
		vsUrl = "http://smsapi.whoisweb.net/emma/EmmaSend.php"
		vsRequestData  = "methodName=EmmaSend&params="&oJSON.JSONoutput()

		Set voHttpReq = Server.CreateObject("MSXML2.ServerXMLHTTP")
		voHttpReq.open "POST", vsUrl, false
		voHttpReq.setRequestHeader "Content-Type", "application/x-www-form-urlencoded"
		voHttpReq.Send(vsRequestData)

		 oJSON.loadJSON(voHttpReq.responseText)

		If oJSON.data("Code") <> "00" then
			ErrMsg = oJSON.data("CodeMsg")
			send = false
		Else
			LastPoint = oJSON.data("LastPoint")
			send = true
		End If

		Set oJSON = Nothing
		Set voHttpReq = Nothing
	End Function

	'***************************************************
	' 현재 남은 포인트 가져오는 함수
	'***************************************************
	Public Function point()
		Set oJSON = New aspJSON
		With oJSON.data
			.Add "Lang", Param.Item("Lang")
			.Add "Char", Param.Item("Char")
			.Add "Id", Param.Item("Id")
			.Add "Pass", Param.Item("Pass")
		End With

		Dim vsUrl,vsRequestData
		vsUrl = "http://smsapi.whoisweb.net/emma/EmmaSend.php"
		vsRequestData  = "methodName=EmmaPoint&params="&oJSON.JSONoutput()

		Set voHttpReq = Server.CreateObject("MSXML2.ServerXMLHTTP")
		voHttpReq.open "POST", vsUrl, false
		voHttpReq.setRequestHeader "Content-Type", "application/x-www-form-urlencoded"
		voHttpReq.Send(vsRequestData)

		 oJSON.loadJSON(voHttpReq.responseText)

		If oJSON.data("Code") <> "00" then
			ErrMsg = oJSON.data("CodeMsg")
			point = false
		Else
			LastPoint = oJSON.data("Point")
			point = true
		End If

		Set oJSON = Nothing
		Set voHttpReq = Nothing
	End Function

	'***************************************************
	' 월별 발송 통계 함수
	'***************************************************
	Public Function statistics (year, month)
		If CInt (year) < 1970 or CInt (month) < 1 or CInt (month) > 12 then
			ErrMsg = "날짜가 잘못되었습니다."
			statistics = false
		Else
			Param.Item("date") = CStr (year) + "-" + CStr (month)

			Set oJSON = New aspJSON
			With oJSON.data
				.Add "Lang", Param.Item("Lang")
				.Add "Char", Param.Item("Char")
				.Add "Id", Param.Item("Id")
				.Add "Pass", Param.Item("Pass")
				.Add "date", Param.Item("date")
			End With

			Dim vsUrl,vsRequestData
			vsUrl = "http://smsapi.whoisweb.net/emma/EmmaSend.php"
			vsRequestData  = "methodName=EmmaStatistic&params="&oJSON.JSONoutput()

			Set voHttpReq = Server.CreateObject("MSXML2.ServerXMLHTTP")
			voHttpReq.open "POST", vsUrl, false
			voHttpReq.setRequestHeader "Content-Type", "application/x-www-form-urlencoded"
			voHttpReq.Send(vsRequestData)

			 oJSON.loadJSON(voHttpReq.responseText)

			If oJSON.data("Code") <> "00" then
				ErrMsg = oJSON.data("CodeMsg")
				statistics = false
			Else
				LastPoint = oJSON.data("Point")
				set Data = oJSON.data("Statistics")
				statistics = true
			End If

			Set oJSON = Nothing
			Set voHttpReq = Nothing
		End If
	End Function


	'***************************************************
	' 클래스를 소멸하면서 개체를 소멸하는 이벤트 핸들러
	'***************************************************
	Private Sub Class_Terminate
		Set Param = Nothing
	End Sub
End Class
%>